Attribute VB_Name = "modExportVCF"
Option Explicit

'Alle Kontakte eines Kontaktordners
'als vCards (vcf-Dateien) speichern
Sub SaveAsVcards()
Dim oShell As Object
Dim oShellFolder As Object
Dim olCFolder As Outlook.MAPIFolder
Dim olC As Object 'Outlook.ContactItem
Dim sShFldName As String
Dim sName As String
Dim sSaveFileName As String

Const INFOTEXT As String = _
  "Wo sollen die Kontakte " & _
  "gespeichert werden?"
  Set oShell = CreateObject("Shell.Application")
  Set oShellFolder = oShell _
      .BrowseForFolder(0, INFOTEXT, 1)
  If oShellFolder Is Nothing Then Exit Sub
  sShFldName = oShellFolder.Self.Path
  
  MsgBox "Bestimmen Sie jetzt den Outlook-" & _
      "Ordner, aus dem die Kontakte " & _
      "gespeichert werden sollen."
  Set olCFolder = Outlook _
      .GetNamespace("MAPI").PickFolder
  If olCFolder Is Nothing Then Exit Sub
  
  If olCFolder.DefaultItemType _
      = olContactItem Then
    For Each olC In olCFolder.Items
      If TypeName(olC) = "ContactItem" Then
        With olC
          sName = Trim _
            (.LastName & " " & _
             .FirstName & " " & _
             .CompanyName)
          sName = ValidFileName(sName)
          sSaveFileName = GetFreeFileName _
              (sShFldName, sName, ".vcf")
          .SaveAs sSaveFileName, olVCard
        End With
      End If
    Next olC
    MsgBox "Kontakte wurden gespeichert."
  Else
    MsgBox "Bitte einen Kontaktordner auswhlen!"
  End If
  Set olC = Nothing
  Set olCFolder = Nothing
  Set oShellFolder = Nothing
  Set oShell = Nothing
End Sub

'Ungltige Zeichen fr Dateinamen entfernen
Function ValidFileName(sText As String) As String
Dim lInvalidCount As Long
Dim c As Long
Const INVALID As String = vbCrLf & "\/:*?<>|"""
  lInvalidCount = Len(INVALID)
  For c = 1 To lInvalidCount
   sText = Replace(sText, Mid(INVALID, c, 1), "")
  Next c
  ValidFileName = sText
End Function

'Bei doppelten Dateinamen Ziffer anhngen
'und nchsten mglichen Dateinamen ausgeben
Function GetFreeFileName _
    (sFolder As String, _
     sName As String, _
     sExt As String) As String
Dim sTmpFile As String
Dim i As Long
  sFolder = IIf(Right(sFolder, 1) <> "\", _
      sFolder & "\", sFolder)
  sTmpFile = sFolder & sName & sExt
  If Dir(sTmpFile) <> "" Then
    i = 2
    sTmpFile = sFolder & sName & " " & i & sExt
    Do Until Dir(sTmpFile) = ""
      i = i + 1
      sTmpFile = sFolder & sName & " " & i & sExt
    Loop
  End If
  GetFreeFileName = sTmpFile
End Function

